Subject: Re: bug#18838: zsh test suite failures, possibly due to 'noatime' mount flag
From: Maxim Cournoyer <[email-masked]>
To: Vincent Legoll <[email-masked]>, "Mark H. Weaver" <[email-masked]>
Cc: [email-masked]
Date: Fri, 25 Jun 2021 21:56:12 -0400
List-Id: <debbugs-submit.debbugs.gnu.org>

Hello,

Maxim Cournoyer <[email-masked]> writes:

> Hello,
>
> Vincent Legoll <[email-masked]> writes:
>
>> Is this still happening?
>>
>> I searched a bit on ci.guix.gnu.org...
>>
>> We have a failure on 5.8 armhf (already present on 5.7.1 version)
>> but it looks like it is a different set of tests that is failing...
>
> I can't find failures in the raw logs of the last CI failures for
> zsh-5.8, but testing on master with:
>
> ./pre-inst-env guix build --check --system=armhf-linux zsh
>
> I got 2 test failures:
>
> Test ./A01grammar.ztst failed: bad status 1, expected 0 from:
>   - $ZTST_testdir/../Src/zsh -fc "[[ \$0 = \"-$ZTST_testdir/../Src/zsh\" ]]"
> Was testing: `-' precommand modifier
> ./A01grammar.ztst: test failed.
> ./A02alias.ztst: starting.
> This test hangs the shell when it fails...
> ./A02alias.ztst: all tests successful.
> ./A03quoting.ztst: starting.
> ./A03quoting.ztst: all tests successful.
> ./A04redirect.ztst: starting.
> ./A04redirect.ztst: all tests successful.
> ./A05execution.ztst: starting.
> Unable to change MONITOR option
> This test takes 5 seconds to fail...
> Skipping pipe leak test, requires MONITOR option
> This test takes 3 seconds and hangs the shell when it fails...
> ./A05execution.ztst: all tests successful.
> ./A06assign.ztst: starting.
> ./A06assign.ztst: all tests successful.
> ./A07control.ztst: starting.
> ./A07control.ztst: all tests successful.
> ./B01cd.ztst: starting.
> Test ./B01cd.ztst failed: bad status 0, expected 1 from:
>  (unset HOME; ARGV0=sh $ZTST_testdir/../Src/zsh -c cd)
> Was testing: Implicit cd with unset HOME.

That was with QEMU user emulation.  Using overdrive1 (real ARM
hardware), I don't get any failure after multiple builds done via:

GUIX_DAEMON_SOCKET=ssh://overdrive1 guix build zsh \
  --system=aarch64-linux --no-grafts --check --rounds=5

It may be that the problem really has to do with the noatime flag, but
that's a bit too narrow for me to test.  If you can reproduce it again
on 5.8 and determine if noatime is at cause, that would be very helpful.

Closing for now, but feel free to reopen!

Maxim